////////////////////////////////////////////////////
// Gingerbread ähnliches Map (zunächst einfarbig)
// als Beispiel für eine Iteration
////////////////////////////////////////////////////
//cx und cy sind die interessanten Parameter, die 
//für das Aussehen der Map verantwortlich sind
float cx, cy;
int [] punktKoord = {0,0};
float[] punkt = {0.0,0.0};
float  xalt, yalt;
int w,h,n,i,f,m,A;
color farbe;
////////////////////////////////////////////////////
void setup() {
  w=900; h=900;
  surface.setSize(w,h);  
  background (255); //weißer Bildhintergrund
  farbe = color(255,0,0);
  xalt= 0.04; yalt= 0;//Startwerte
  cx = 1.8; cy = 1; //Wahl der Parameter
  n= 200000;//maximale Anzahl der Iterationschritte
  A= 200;
  i =0; f=0;
}
////////////////////////////////////////////////
float[] iteration(float x, float y){
  float xalt = x; float yalt = y;
  punkt[0] = 1-yalt+cx*abs(xalt); 
  punkt[1] = cy*xalt;
  return punkt;
}
///////////////////////////////////////////////////
int[] koordinaten(float x, float y){
  //Bildausschnitt links unten (xu;yu), rechts oben (xo,yo)
  int xu = -100; int xo = 300;
  int yu = -100; int yo = 300;
  float xneu = x; float yneu = y;
   punktKoord[0] = round((xneu-xu)/(xo-xu)*w);
   punktKoord[1] = round((yo-yneu)/(yo-yu)*h);
   return punktKoord; 
}

//////////////////////////////////////////////////////////
void draw () {
  //m definiert, um bei i = A, 2A, 3A,...die nächsten
  //A Punkte zu zeichnen
    m=i+A; 
   if(m<=n){
     stroke(farbe);
     while ((i<m) && (abs(xalt)<100000) &&  (abs(yalt)<100000)) {
      //stoppt wenn maximale Induktionstiefe erricht oder  bei Divergenz    
       punkt = iteration(xalt,yalt);
       xalt = punkt[0]; yalt = punkt[1];
       punktKoord = koordinaten(xalt,yalt);  
       point(punktKoord[0],punktKoord[1]);
       i++;
     }
  }
  //Stoppen, wenn eine der drei Bedingungen erfüllt ist  
   if (i>=n){
      println("fertig");//zeigt das Ende der Berechnung an
     //saveFrame("GingerBreadMan.jpg");//Falls speichern erwünscht
     noLoop();   
   }   
}